type __ = Obj.t

type nat =
  | O
  | S of nat

type 'a sig0 = 'a
  (* singleton inductive, whose constructor was exist *)

type sumbool =
  | Left
  | Right

val plus : nat -> nat -> nat

val minus : nat -> nat -> nat

type 'a list =
  | Nil
  | Cons of 'a * 'a list

val length : 'a1 list -> nat

val nth : nat -> 'a1 list -> 'a1 -> 'a1

val map : ('a1 -> 'a2) -> 'a1 list -> 'a2 list

val le_lt_dec : nat -> nat -> sumbool

val seq : nat -> nat -> nat list

type type0 =
  | Int
  | Arrow of type0 * type0

type term =
  | Zero
  | Succ of term
  | Var of nat
  | App of term * term
  | Abs of type0 * term
  | R of type0 * term * term * term

val dtype : type0

val arrow_right : type0 -> type0

val type_dec : type0 -> type0 -> sumbool

val up : nat -> term -> term

type substitution = { support : term list; shift : nat }

val support : substitution -> term list

val shift : substitution -> nat

val sublift : substitution -> substitution

val sub : term -> substitution -> term

val id : nat -> substitution

type context = type0 list

val typ : context -> term -> type0

type ('a, 'b) prod =
  | Pair of 'a * 'b

type 'b halfprod =
  'b
  (* singleton inductive, whose constructor was halfpair *)

module type RedSem = 
 sig 
  
 end

module NormalizationProof : 
 functor (R:RedSem) ->
 sig 
  type halts = term
  
  type coq_RR = __
  
  type coq_RRs = __
  
  val coq_RRs_nth :
    type0 list -> type0 -> term list -> term -> nat -> coq_RRs -> coq_RR
  
  val coq_RR_implies_halt : type0 -> term -> coq_RR -> halts
  
  val coq_Red_inv_preserves_RR : type0 -> term -> term -> coq_RR -> coq_RR
  
  val coq_RedTrans_inv_preserves_RR :
    type0 -> term -> term -> coq_RR -> coq_RR
  
  val coq_R_aux :
    term -> type0 -> term -> term -> term -> coq_RR -> (halts, term -> halts
    halfprod -> (halts, term -> __ -> __) prod halfprod) prod halfprod ->
    coq_RR
  
  val subst_preserves_RR :
    term -> substitution -> context -> type0 -> coq_RRs -> coq_RR
  
  val whnf : term -> type0 -> halts
  
  type coq_Answer =
    | No
    | Yes of term
  
  val coq_Answer_rect : 'a1 -> (term -> 'a1) -> coq_Answer -> 'a1
  
  val coq_Answer_rec : 'a1 -> (term -> 'a1) -> coq_Answer -> 'a1
  
  val typ_dec : term -> context -> type0 -> sumbool
  
  val whnf_total : term -> type0 -> coq_Answer
 end

module Req : 
 sig 
  
 end

module Proof : 
 sig 
  type halts = term
  
  type coq_RR = __
  
  type coq_RRs = __
  
  val coq_RRs_nth :
    type0 list -> type0 -> term list -> term -> nat -> coq_RRs -> coq_RR
  
  val coq_RR_implies_halt : type0 -> term -> coq_RR -> halts
  
  val coq_Red_inv_preserves_RR : type0 -> term -> term -> coq_RR -> coq_RR
  
  val coq_RedTrans_inv_preserves_RR :
    type0 -> term -> term -> coq_RR -> coq_RR
  
  val coq_R_aux :
    term -> type0 -> term -> term -> term -> coq_RR -> (halts, term -> halts
    halfprod -> (halts, term -> __ -> __) prod halfprod) prod halfprod ->
    coq_RR
  
  val subst_preserves_RR :
    term -> substitution -> context -> type0 -> coq_RRs -> coq_RR
  
  val whnf : term -> type0 -> halts
  
  type coq_Answer =
    | No
    | Yes of term
  
  val coq_Answer_rect : 'a1 -> (term -> 'a1) -> coq_Answer -> 'a1
  
  val coq_Answer_rec : 'a1 -> (term -> 'a1) -> coq_Answer -> 'a1
  
  val typ_dec : term -> context -> type0 -> sumbool
  
  val whnf_total : term -> type0 -> coq_Answer
 end

